// Euclids Extended Algorithm  1.3.6  from "A course in computational algebraic number theory"  by Henri Cohen
// This is required for Algorithm 10.3.4 (Parallel Inverse Modulo N) Henri Cohen page 489-490. To compute
// (u,v,d) such that u ck + v N = d. and d = (ck,N).
// To see how this relates to affine coordinates on the Weierstrass equation and Montgomery Group. Check out
// Theory on this website button, Web page "Appendix 1". 

#include <iostream>
#include <cmath>
using namespace std;


int Extended_Euclidean_Iterative1(int a, int b, int* u, int* v)
{
	int v1 = 0; int v3 = 0; int t1 = 0; int t3 = 0; int q = 0;
	*u = 1;
	int RD = a;
	if (b == 0) {
		*v = 0;
		return 0;
	}
	else {
		v1 = 0;
		v3 = b;
	}
	do {
		if (v3 == 0) {
			*v = (RD - (a * (*u))) / b;
			cout << "*v = " << *v << endl;
			cout << "*u = " << *u << endl;
			return RD;
			break;
		}
		q = (RD / v3);
		t3 = (RD % v3);
		t1 = *u - (q * v1);
		*u = v1;
		RD = v3;
		v1 = t1;
		v3 = t3;
	} while (v3 >= 0);
}

int main()
{
	int u; int v;
	int a; int b;
	cout << "Enter number a " << endl;
	cin >> a;
	cout << " Enter number b " << endl;
	cin >> b;
	cout << "(au + bv = d) d = " << Extended_Euclidean_Iterative1(a, b, &u, &v) << endl;
}